#pragma once

#include <time.h>
#include "apr_general.h"
#include "apr_hash.h"
#include "svn_wc.h"
#include "msscc.h"

#define CACHETIMEOUT 300000		// 5 min

class CStatusCache
{
public:
	CStatusCache(void);
	~CStatusCache(void);
public:
	struct cacheData_t 
	{
		LONG sccstatus;
		time_t fileTime;
		svn_wc_status_kind status;
		//svn_wc_status_t * status;
		char * fileName;
	};

protected:
	apr_hash_t *m_StatusCacheHash;
	apr_pool_t *m_Pool;
	void initialize(void);
	DWORD lastFullUpdate;
	cacheData_t * lastAccessedData;

public:
	BOOL Set(CString fileName, svn_wc_status_kind status, LONG sccstatus);
	cacheData_t * Get(CString fileName);

	BOOL isInitialized();
	
	svn_wc_status_kind getStatus(CString fileName);
	LONG getSCCStatus(CString fileName);
	
	BOOL isEmpty();
	BOOL isObsolete();
	BOOL isObsolete(CString fileName);
	void fullUpdate();
	void clean();

	BOOL SCCPopulate(CString fileName, POPLISTFUNC pfnPopulate, LPVOID pvCallerData);

	void update(LONG nFiles, LPCSTR* lpFileNames);
	void update(CString fileName);

	BOOL remove(CString fileName);
	void remove(LONG nFiles, LPCSTR* lpFileNames);

protected:
	BOOL getSVNStatusForFolder(CString _fileName);
	BOOL getSVNStatusForFile(CString _fileName);
	BOOL getSVNStatusForFiles(LONG nFiles, LPCSTR* lpFileNames);

	CString getCacheName();
	BOOL readCache(CString dirname);
	BOOL writeCache(CString dirname);	
};

void getstatushash(void * baton, const char * path, svn_wc_status_t * status);